/**
* Made by Linus Sylvn 4 anyone to enjoy
* linus.sylven@bredband.net
*/

import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;

class CalcCube extends JFrame implements ActionListener, Runnable{
  public static final long serialVersionUID = 200511011157L;
  LongRTM rtm;
  JButton jbcalc = new JButton("Calc"), jbstop = new JButton("Stop");
  JTextArea tf = new JTextArea();
  JTextField jtf = new JTextField(25);
  JScrollPane scp = new JScrollPane(tf);
  boolean go = true;
  String tofile="";
  Integer[][][] memoryloadtester1;
  VirtualCube2x2[] memoryloadtester2;
  
  public static void main(String[] args){new CalcCube();}
  
  CalcCube(){
    setDefaultCloseOperation(EXIT_ON_CLOSE);
    JPanel jpSouth = new JPanel(new GridLayout(1,2));
    jpSouth.add(jbcalc);
    jpSouth.add(jbstop);
    add("South", jpSouth);
    add("Center", scp);
    add("North", jtf);
    jbcalc.addActionListener(this);
    jbstop.addActionListener(this);
    setSize(500,500);
    setVisible(true);
  }
  
  void calc(){
    float enc = 3674160*6, ncp = 0;
    long startT=0;
    try{
      int max = 1350852;
      ArrayList<int[][]> joblist1 = new ArrayList<int[][]>(max), joblist2 = new ArrayList<int[][]>(max);
      byte thisDept=0; 
      int moves=1, totMoves=1;
      VirtualCube2x2 cc = new VirtualCube2x2();
      String state = "Level "+ thisDept +" = "+ moves +" permutations, and "+ totMoves + " permutations totaly \n"; 
      tofile+=state;
      tf.append(state);
      rtm = new LongRTM("cube.dat", true);
      rtm.put(cc.getState(), (byte)0, thisDept++, -1);
      joblist1.add(cc.cube);
      long prev_state;
      startT = System.currentTimeMillis();
      do{
        joblist2.addAll(joblist1);
        joblist1.clear();
        moves=0;
        
        Iterator<int[][]> iter = joblist2.iterator();
        while(iter.hasNext() && go){
          VirtualCube2x2 temp = new VirtualCube2x2(iter.next());
          prev_state = temp.getState();
          for(int j=1; (go && j<7); j++){
            ncp++;
            VirtualCube2x2 ncc = new VirtualCube2x2(temp.cube);
            ncc.turn(j);
            if(rtm.put(ncc.getState(), (byte)j, thisDept, prev_state)){
              joblist1.add(ncc.cube);
              jtf.setText("moves :: "+totMoves++ +" <-->  remaining time = "+ 
                Math.round((System.currentTimeMillis() - startT) / (ncp) * (enc-ncp) / 1000)
                + " sec");
              moves++;
            }
          }
          iter.remove();
        }
        
        
        //~ for(int i=0; (go && i<joblist2.size()); i++){
          //~ VirtualCube2x2 temp = new VirtualCube2x2(joblist2.get(i));
          //~ prev_state = temp.getState();
          //~ for(int j=1; (go && j<7); j++){
            //~ ncp++;
            //~ VirtualCube2x2 ncc = new VirtualCube2x2(temp.cube);
            //~ ncc.turn(j);
            //~ if(rtm.put(ncc.getState(), (byte)j, thisDept, prev_state)){
              //~ joblist1.add(ncc.cube);
              //~ jtf.setText("moves :: "+totMoves++ +" <-->  remaining time = "+ 
                //~ Math.round((System.currentTimeMillis() - startT) / (ncp) * (enc-ncp) / 1000)
                //~ + " sec");
              //~ moves++;
            //~ }
          //~ }
        //~ }
        
        
        joblist2.clear();
        state = "Level "+ thisDept++ +" = "+ moves +" permutations, and "+ totMoves + " permutations totaly \n"; 
        tofile+=state;
        tf.append(state);
      }while(go && joblist1.size()>0);
    }catch(Exception e){}
    try{
      tofile+="\n Time sek = "+((System.currentTimeMillis()-startT)/1000);
      FileWriter outputFileReader  = new FileWriter("calc.txt");
      PrintWriter outputStream  = new PrintWriter(outputFileReader);
      outputStream.println(tofile);
      outputStream.close();
    }catch(IOException ioe){
      System.err.println(ioe);
    }
    tf.append(tofile);
  }
  
  public void run(){
    calc();
    System.exit(0);
  }

  void start(){
    Thread thread = new Thread(this);
    thread.setPriority(Thread.MIN_PRIORITY);
    thread.start();
  }
  
  public void actionPerformed(ActionEvent e){ 
    if(e.getActionCommand().equals("Calc")){ 
      start();
    }
    if(e.getActionCommand().equals("Stop")){ 
      go=false;
    }
  }// Action prformed

}
