/**
* Made by Linus Sylvn 4 anyone to enjoy
* linus.sylven@bredband.net
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

public class MainFrame extends JApplet{
  public static final long serialVersionUID = 200511011158L;
  Rubik2x2Cube rc;
  static Color bgcolor = new Color(240,240,240); 
  
  public static void main(String[] p){ JFrame.setDefaultLookAndFeelDecorated(true); new Rubik2x2();}

  public void init(){
    try{ bgcolor = stringToColor(getParameter("bgcolor"));}catch(Exception e){}
    rc = new Rubik2x2Cube(bgcolor);
    setLayout(new BorderLayout());
    add("Center", rc.jp);
    JPanel jpanel = new JPanel();
    jpanel.setBackground(bgcolor);
    jpanel.add(rc.jbFarthest);
    jpanel.add(rc.jbRandom);
    jpanel.add(rc.jbSolve);
    add("South", jpanel);
    add("North", rc.jpb);
  }
  
  Color stringToColor(String strin){
    int r=0, g=0 , b=0;
    try{
      StringTokenizer tok = new StringTokenizer(strin.trim(),",");
      r = Integer.parseInt(((String)tok.nextElement()).trim());
      g = Integer.parseInt(((String)tok.nextElement()).trim());
      b = Integer.parseInt(((String)tok.nextElement()).trim());
    } catch(Exception e){
      r = hexToDec(strin.trim().substring(0,2));
      g = hexToDec(strin.trim().substring(2,4));
      b = hexToDec(strin.trim().substring(4,6));
    }
    return new Color(r,g,b);
  }
  
  private static int hexToDec(String strin){
    Long l=new Long(0);
    try{
      l = Long.decode("0x"+strin);
    }catch(Exception e){}
    return l.intValue();
  }

static class Rubik2x2 extends JFrame{
  public static final long serialVersionUID = 2005110111589L;
  Rubik2x2Cube rc;
  int h = 666, w = 600;
  
  Rubik2x2(){
    rc = new Rubik2x2Cube(bgcolor);
    setDefaultCloseOperation(EXIT_ON_CLOSE);
    setLayout(new BorderLayout());
    setTitle("Rubik's 2x2x2 - puzzle");
    add("Center", rc.jp);
    JPanel jpanel = new JPanel();
    jpanel.add(rc.jbFarthest);
    jpanel.add(rc.jbRandom);
    jpanel.add(rc.jbSolve);
    add("South", jpanel);
    add("North", rc.jpb);
    setSize(w, h);
    setVisible(true);
  }

}//**class RubCube

}
