/**
* Made by Linus Sylvn 4 anyone to enjoy
* linus.sylven@bredband.net
*/

import java.awt.*;

class VirtualCubeMapper{
  Color[] colors = new Color[7];
  
  VirtualCube2x2 vicube;

  VirtualCubeMapper(VirtualCube2x2 vicube){
    this.vicube = vicube;

    colors[0] = new Color(255, 0, 0);
    colors[1] = new Color(0, 0, 255);
    colors[2] = new Color(255,140,0);
    colors[3] = new Color(255, 0, 255);
    colors[4] = new Color(245, 249, 60);
    colors[5] = new Color(77, 194, 62);
    colors[6] = new Color(128,128,128);

  }//VirtualCubeMapper(VirtualCube2x2 vicube)
    
  Color colorMapping(int x, int y){
    Color retur;
    switch(vicube.cube[x][y]){
      case 1: return colors[0]; 
      case 2: return colors[1]; 
      case 3: return colors[2]; 
      case 4: return colors[3]; 
      case 5: return colors[4]; 
      case 6: return colors[5]; 
      default: return colors[6]; 
    }
  }

}